; (c) 2019 by Udo Egner-Walter

include "hjConst.jsh"
include "hjGlobal.jsh"
include "common.jsm"
Include "UIA.jsh"
include "ewTextModule.jsh"
include "ewTextModule.jsm"

use "UIA.jsb"

; ooooooooooooooooooooooooooooooooooooooooooooooooo
; Funktionen
; ooooooooooooooooooooooooooooooooooooooooooooooooo


; -----------------------------------------------------------------------------------------------
; Wenn Textbausteine-Verwaltung aktiv, dann BrailleBuildStatus
; berschreiben (sonst wird in Word nichts angezeigt)
; -----------------------------------------------------------------------------------------------

int function BrailleBuildStatus()
If gbBrlBStatus then
Return False
else
Return BrailleBuildStatus ()
EndIf
EndFunction

; -----------------------------------------------------------------------------------------------
; Tastatureingaben berwachen, ob JAWS+V gedrckt wurde
; funktioniert leider noch nicht
; -----------------------------------------------------------------------------------------------

void Function ProcessKeyPressed (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
If strKeyName == "JAWSKey+V" then
SayString ("erkannt")
gbIsQuickSettingActive = True
EndIf 
ProcessKeyPressed (nKey,strKeyName,nIsBrailleKey,nIsScriptKey)
EndFunction 

; -----------------------------------------------------------------------------------------------
; Schnelleinstellungen mit ESC verlassen
; -----------------------------------------------------------------------------------------------

Void Function CloseQuickSettings ()
TypeKey ("Escape")
EndFunction 

; -----------------------------------------------------------------------------------------------
; Prfen, ob beim aktuellen Steuerelement Text eingefgt werden kann
; -----------------------------------------------------------------------------------------------

int Function CanPaste ()
var
object oUIA = CreateObjectEx ("FreedomSci.UIA", false, "UIAScriptAPI.x.manifest" ),
object oElement = GetUIAFocusElement(oUIA)

if oElement.ControlType == UIA_EditControlTypeId 
|| oElement.ControlType == UIA_WindowControlTypeID
|| oElement.ControlType == UIA_CustomControlTypeId
|| oElement.ControlType ==UIA_DocumentControlTypeId  then
Return True
else
Return False
EndIf 
EndFunction 

; -----------------------------------------------------------------------------------------------
; zeigt Text auf der Braille-Zeile an
; -----------------------------------------------------------------------------------------------

void Function SendToBraille (string sMessage)
If gbUseFlashMessage then
BrailleMessage (sMessage)
else
BrailleString (sMessage)
EndIf ; If gbUseFlashMessage then
EndFunction

; ---------------------------------------------------------------------------------------------
; den Text des Textbausteins mit bestimmter Nummer sprechen
; ---------------------------------------------------------------------------------------------

void Function SpeakTextModuleNumber (int iTextModuleNumber)
var
; alle Eintrge in oEntries laden 
object oEntries = goTextModuleFile.getElementsByTagName("entry"),
; Anzahl der Eintrge bestimmen
int iCount = oEntries.Length,
; den Text des Bausteins (iTextModuleNumber) ermitteln 
string sText = oEntries(iTextModuleNumber-1).FirstChild.Text
sText = StringReplaceSubstrings (sText, "#", "Absatz")

; Wenn der Text leer ist (= drfte eigentlich nicht vorkommen)
if sText == "" then
; Fehlermeldung ausgeben 
sText = MsgCDataNotFound
EndIf ; if sText == "" then
; Meldung und Text sprechen

SayFormattedMessage (OT_SCREEN_MESSAGE, MsgActTextModule, MsgActTextModule, iTextModuleNumber, iCount, sText)
SendToBraille (FormatString(MsgActTextModule, iTextModuleNumber, iCount, sText))
EndFunction 

; ---------------------------------------------------------------------------------------------
; Textbaustein Nummer verndern und abspeichern 
; ---------------------------------------------------------------------------------------------

void Function PlayTextModulSound ()
If !gbTextModuleActive then
Return
EndIf 

If FileExists (FindJAWSSoundFile (cSoundMove)) then
PlaySound (FindJAWSSoundFile (cSoundMove))
endIf ; if FileExists

EndFunction 

; ---------------------------------------------------------------------------------------------
; Textbaustein Nummer verndern und abspeichern 
; ---------------------------------------------------------------------------------------------

int Function SetTextModulNumber (int iOption, optional string sMessage)
var
; zuletzt gespeichert Position in oPosition speichern 
object oPosition = goTextModuleFile.selectSingleNode("//settings/@position"),
; alle Eintrge laden 
object oEntries = goTextModuleFile.getElementsByTagName("entry"),
; Anzahl der Eintrge ermitteln 
int iCount = oEntries.Length,
; Position von oPosition (Text) in Zahl umwandeln und in iPos speichern 
int iPos = StringToInt (oPosition.Text)

; erster Textbaustein 
If iOption == cFirst then
; Position auf 1 setzen 
iPos = 1
oPosition.Text = iPos
EndIf ; If iOption == cFirst then

; letzter Textbaustein
If iOption == cLast then
; Position auf letzten Eintrag (= Anzahl Eintrge)
iPos = iCount
oPosition.Text = iPos
EndIf ; If iOption == cLast then

; nchster Textbaustein
If iOption == cNext then
; Position um 1 erhhen
iPos = iPos+1
; wenn die Position (nach dem Addieren) grer ist als die 
; Zahl der Eintrge 
if iPos > iCount then
; Position auf ersten Eintrag setzen 
iPos = 1
EndIf ; if iPos > iCount then
oPosition.Text = iPos
EndIf ; If iOption == cNext then

; vorheriger Textbaustein 
If IOption == cPrior then
; Position um 1 verringern
iPos = iPos - 1
; wenn die Position (nach dem Subrahieren) 0 ist
if iPos == 0 then
; Position auf letzten Eintrag setzen 
iPos = iCount 
EndIf ; if iPos == 0 then
oPosition.Text = iPos
EndIf ; If IOption == cPrior then

; 10 Textbausteine nach vorne 
If iOption == cNext10 then
; Position um 10 erhhen
iPos = iPos +10
; wenn die Position (nach dem Addieren) grer als die Anzahl 
; Eintrge ist (= Ende erreicht)
if iPos > iCount then
; Position auf letzten Eintrag setzen 
iPos = iCount 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgTextModuleEnd)
SendToBraille (MsgTextModuleEnd)
EndIf ; if iPos > iCount then
oPosition.Text = iPos
EndIf ; If iOption == cNext10 then

; 10 Textbausteine nach hinten 
If iOption == cPrior10 then
; Position um 10 verringern
iPos = iPos - 10
; wenn die Position (nach dem Subrahieren) kleiner als 0 ist
; (= Anfang erreicht)
if iPos < 0 then
; Position auf ersten Eintrag setzen 
iPos = 1
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgTextModuleBegin)
SendToBraille (MsgTextModuleBegin)
EndIf ; if iPos < 0 then
oPosition.Text = iPos
EndIf ; If iOption == cPrior10 then

; Datei speichern 
goTextModuleFile.Save (gsFilename)

; Nachricht sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, sMessage)
SendToBraille (sMessage)
; sowei Textbaustein-Text sprechen 
SpeakTextModuleNumber (iPos)
EndFunction 

; -----------------------------------------------------------------------------------------------
; Textbausteine einfgen
; -----------------------------------------------------------------------------------------------

void Function CobraInsertTextModule (int iOption)
; Wenn Warnungen gesprochen werden sollen und Text nicht eingefgt werden kann 
If gbSayWarnings && !CanPaste() then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgCannotInsertTextModule)
PerformScript EndCobraTextModules ()
Return
EndIf ; If gbSayWarnings && !CanPaste() then
var
object oEntries,
object oEntry,
object oPosition,
int iPos, 
string sText
; alle Eintrge laden 
oEntries = goTextModuleFile.getElementsByTagName("entry")
; Position laden
oPosition = goTextModuleFile.selectSingleNode("//settings/@position")
; zuletzt gespeicherte Position extrahieren 
iPos = StringToInt (oPosition.Text) 
; Untereintrag laden 
oEntry = oEntries(iPos-1).FirstChild
; Text extrahieren 
sText = oEntry.Text
; # umwandeln in Zeilenumbrche 
sText = StringReplaceSubstrings (sText, "#", "\13\10")

; Einfge-Optionen beachten 

; Textbausteine ber Zwischenablage in Text einfgen 
If iOption == cInsertFromClipboard then 
CopyToClipboard (sText)
TypeKey ("Control+V")
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgInsertTextModule)
SendToBraille (MsgInsertTextModule)
; Textbausteine "schreiben" mit TypeString ()
elIf iOption == cInsertWithTypeString then
TypeString (sText)
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgInsertTextModule)
SendToBraille (MsgInsertTextModule)
; Textbaustein nur in die Zwischenablage einfgen 
elIf iOption == cInsertToClipboard then
CopyToClipboard (sText)
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgInsertTextModuleToClipboard)
SendToBraille (MsgInsertTextModuleToClipboard)
EndIf 
; global merken, dass Textbausteinbearbeitung beendet ist 
gbTextModuleActive = False
EndFunction

; ooooooooooooooooooooooooooooooooooooooooooooooooo
; Skripts
; ooooooooooooooooooooooooooooooooooooooooooooooooo

; ---------------------------------------------------------------------------------------------
; Initialisieren der Textbausteine
; ---------------------------------------------------------------------------------------------

Script StartCobraTextModules ()
var
object oData, 
object oIntro,
object oSettings,
object oEntry,
object oCData,
int i, 
int iCount,
int iPos,
object oEntries, 
object oPosition, 
string sText

; giWindowTypeCode = GetWindowTypeCode(GetCurrentWindow ())

gbBrlBStatus = True
gbUseFlashMessage = IniReadInteger (cQuickSettingsSection, cQuickSettingsBrailleKey, 0, cQuickSettingsININame)
gbSayWarnings = IniReadInteger (cQuickSettingsSection, cQuickSettingsSayWarningsKey, 0, cQuickSettingsININame)
gbSayPositionKeys = IniReadInteger (cQuickSettingsSection, cQuickSettingsSayPositionKeys, 0, cQuickSettingsININame)

SayFormattedMessage (OT_SCREEN_MESSAGE, MsgStart)
SendToBraille (MsgStart)
; Merken, dass Textbausteine aktiv sind 
gbTextModuleActive = True
; Dateinamen fr XML-Datei zusammenstellen 
gsFilename = GetJAWSSettingsDirectory () + "\\" + cFilename
; MSXML-COM-Objekt erstellen 
goTextModuleFile = CreateObject("msxml2.DOMDocument.6.0")
; Einstellungen vornehmen 
goTextModuleFile.async = false;
goTextModuleFile.resolveExternals = false;
goTextModuleFile.setProperty("SelectionLanguage", "XPath")
; Falls die Textbausteindatei schon existiert 
If FileExists (gsFilename) then
; dies melden und Datei laden 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgLoadXML)
SendToBraille (MsgLoadXML)
goTextModuleFile.Load (gsFilename)
else ; andernfalls Datei neu erstellen 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgCreateXML)
SendToBraille (MsgCreateXML)
; mit ntigen Knoten fllen 
oData = goTextModuleFile.createElement("data")
goTextModuleFile.appendChild(oData)
oData = goTextModuleFile.DocumentElement
oSettings = goTextModuleFile.createElement("settings")
oSettings.SetAttribute ("position", "1")
oData.AppendChild (oSettings)
oIntro = goTextModuleFile.createProcessingInstruction("xml","version='1.0'")
goTextModuleFile.insertBefore(oIntro, goTextModuleFile.childNodes(0))
; eigentliche Eintrge ber Schleife hinzufgen 
for i=1 to 10
oEntry = goTextModuleFile.createElement("entry")
oEntry.SetAttribute("name", "Eintrag"+IntToString(i))
oCData = goTextModuleFile.createCDATASection ("leer")
oEntry.AppendChild (oCData)
oData = goTextModuleFile.getElementsByTagName("data").item(0)
oData.appendChild(oEntry)
EndFor 
; Datei speichern 
goTextModuleFile.Save (gsFilename)
EndIf ; If FileExists (gsFilename) then
; alle Eintrge laden 
oEntries = goTextModuleFile.getElementsByTagName("entry")
; Anzahl Eintrge bestimmen 
iCount = oEntries.Length
; letzte Position laden 
oPosition = goTextModuleFile.selectSingleNode("//settings/@position")
; zuletzt gespeicherte Position extrahieren 
iPos = StringToInt (oPosition.Text)
; Text anhand der aktuellen Position ermitteln 
; (Zhlung beginnt mit 0, deshalb 1 abziehen)
sText =  oEntries(iPos-1).FirstChild.Text
; wenn der Text leer ist, wurde nichts gefunden, 
if sText == "" then
; Fehlermeldung ausgeben 
sText = MsgCDataNotFound
EndIf ; if sText == "" then
; Meldung und Text sprechen

SayFormattedMessage (OT_SCREEN_MESSAGE, MsgActTextModule, MsgActTextModule, iPos, iCount, sText)
SendToBraille (FormatString(MsgActTextModule, iPos, iCount, sText))

PlayTextModulSound ()
EndScript

; ---------------------------------------------------------------------------------------------
; Textbausteine-Betrachtung beenden 
; ---------------------------------------------------------------------------------------------

Script EndCobraTextModules ()
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgEnd)
SendToBraille (MsgEnd)
; merken, dass Textbausteine beendet sind 
gbTextModuleActive = False
gbBrlBStatus = False
CancelLayeredKeySequence ()
EndScript

; ---------------------------------------------------------------------------------------------
; Zum ersten Textbaustein wechseln
; ---------------------------------------------------------------------------------------------

Script CobraFirstTextModule ()
If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then
If gbSayPositionKeys then
SetTextModulNumber (cFirst, MsgFirstTextModule)
else
SetTextModulNumber (cFirst)
EndIf ; If gbSayPositionKeys then
PlayTextModulSound ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Zum letzten Textbaustein wechseln
; ---------------------------------------------------------------------------------------------

Script CobraLastTextModule  ()
If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then
If gbSayPositionKeys then
SetTextModulNumber (cLast, MsgLastTextModule)
else
SetTextModulNumber (cLast)
EndIf ; If gbSayPositionKeys then
PlayTextModulSound ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Nchsten Textbaustein aus der Liste whlen
; ---------------------------------------------------------------------------------------------

Script CobraNextTextModule ()
If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

If gbSayPositionKeys then
SetTextModulNumber (cNext, MsgNextTextModule)
else
SetTextModulNumber (cNext)
EndIf ; If gbSayPositionKeys then

PlayTextModulSound ()
EndScript

; ---------------------------------------------------------------------------------------------
; Vorherigen Textbaustein aus der Liste whlen
; ---------------------------------------------------------------------------------------------

Script CobraPriorTextModule ()
If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

If gbSayPositionKeys then
SetTextModulNumber (cPrior, MsgPriorTextModule)
else
SetTextModulNumber (cPrior)
EndIf ; If gbSayPositionKeys then

PlayTextModulSound ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Aktueller Textbaustein - 10
; ---------------------------------------------------------------------------------------------

Script CobraPrior10TextModule ()
If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

If gbSayPositionKeys then
SetTextModulNumber (cPrior10, MsgPrior10TextModule)
else
SetTextModulNumber (cPrior10)
EndIf ; If gbSayPositionKeys then

PlayTextModulSound ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Aktueller Textbaustein + 10
; ---------------------------------------------------------------------------------------------

Script CobraNext10TextModule ()
If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

If gbSayPositionKeys then
SetTextModulNumber (cNext10, MsgNext10TextModule)
else
SetTextModulNumber (cNext10)
EndIf ; If gbSayPositionKeys then

PlayTextModulSound ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Aktuellen Textbaustein an Cursor-Position einfgen 
; ---------------------------------------------------------------------------------------------

Script CobraInsertTextModule ()
; cInsertWithTypeString = 1, 
; cInsertFromClipboard = 2, 
; cInsertToClipboard = 3
; ChangeInsertMethode hinzufgen !!!

If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendtoBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

CobraInsertTextModule (cInsertFromClipboard)
PlayTextModulSound ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Gewhlen Textbaustein aus der Liste lschen
; ---------------------------------------------------------------------------------------------

Script CobraDeleteTextModule ()
var
object oEntries,
object oEntry,
object oPosition,
int iPos, 
string sText

If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

; alle Eintrge laden 
oEntries = goTextModuleFile.getElementsByTagName("entry")
; Position laden
oPosition = goTextModuleFile.selectSingleNode("//settings/@position")
; zuletzt gespeicherte Position extrahieren 
iPos = StringToInt (oPosition.Text) 

; Standardtext fr gelschte Textbausteine ist "leer"
sText = "leer"
oEntry = oEntries(iPos-1).FirstChild
oEntry.Text = sText

; aktuellen Textbaustein in oEntry laden 
oEntry = oEntries(iPos-1)
; Wenn im 1. Attribut das Wort "LschEintrag" steht, dann 
If oEntry.Attributes(0).Text == "LschEintrag" then
; Knoten vollstndig aus Datei entfernen 
oEntry.ParentNode.RemoveChild (oEntry)
; da die aktuelle Position beim kompletten Lschen nicht mehr stimmt, eins abziehen 
iPos = iPos - 1
oPosition.Text = iPos 
; und Meldung sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgDeleteTextModuleFromFile)
SendToBraille (MsgDeleteTextModuleFromFile)
else ; andernfalls (Eintrag soll nicht komplett gelscht werden) 
; lediglich Meldung ausgeben (Text wurde zuvor mit dem Inhalt "leer" erstellt
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgDeleteTextModule)
SendToBraille (MsgDeleteTextModule)
EndIf ; If oEntry.Attributes(0).Text == "LschEintrag" then
; zum Schluss nderungen abspeichern 
goTextModuleFile.Save (gsFilename)

PlayTextModulSound ()
PerformScript EndCobraTextModules ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Einen Textbaustein (1 bis 10) auswhlen 
; ---------------------------------------------------------------------------------------------

Script CobraJumpTo (int iNumber)
var
int iTextModule = iNumber,
object oEntries, 
object oPosition

If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

; Wenn 0 als Zahl bergeben wurde
If !iTextModule then
; ist 10 gemeint!
iTextModule = 10
EndIf ; If !iTextModule then

; alle Eintrge laden 
oEntries = goTextModuleFile.getElementsByTagName("entry")
; Position laden
oPosition = goTextModuleFile.selectSingleNode("//settings/@position")
; neue Position festlegen 
oPosition.Text = IntToString (iTextModule)
; und speichern 
goTextModuleFile.Save (gsFilename)
; Melden, zu weler Nummer gesprungen wurde
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgJumpTo, MsgJumpTo, iTextModule)
SendToBraille (FormatString(MsgJumpTo, iTextModule))
SpeakTextModuleNumber (iTextModule)
PlayTextModulSound ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Text aus Zwischenablage an aktueller Position einfgen 
; ---------------------------------------------------------------------------------------------

Script CobraInsertFromClipboard ()
var
object oEntries,
object oEntry,
object oPosition,
int iPos, 
string sText

If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

; alle Eintrge laden 
oEntries = goTextModuleFile.getElementsByTagName("entry")
; Position laden
oPosition = goTextModuleFile.selectSingleNode("//settings/@position")
; zuletzt gespeicherte Position extrahieren 
iPos = StringToInt (oPosition.Text) 
; Text aus Zwischenablage auslesen 
sText = GetTextFromClipboard ()
; wenn der Text leer ist, wurde nichts gefunden, 
if sText == "" then
sText = "leer"
EndIf 
; Zeilenumbrche als "#" speichern (da diese in der XML entfernt werden)
sText = StringReplaceSubstrings (sText, "\13\10", "#")
; erster Unterknoten (Baustein) auswhlen 
oEntry = oEntries(iPos-1).FirstChild
; Text dort einfgen 
oEntry.Text = sText
; und speichern 
goTextModuleFile.Save (gsFilename)
; Meldung und Text sprechen
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgInsertFromClipboard)
SendToBraille (MsgInsertFromClipboard)
PerformScript EndCobraTextModules ()
EndScript 

; ---------------------------------------------------------------------------------------------
; Leeren Textbaustein am Ende einfgen 
; ---------------------------------------------------------------------------------------------

Script CobraNewTextModule ()
var
object oData, 
object oEntry,
object oCData

If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgNotStartet)
SendToBraille (MsgNotStartet)
Return
EndIf ; If !gbTextModuleActive then

; neuen Knoten "entry" erstellen 
oEntry = goTextModuleFile.createElement("entry")
; da dieser spter komplett gelscht werden kann, bekommt er 
; das Attribut "name" den Wert "LschEintrag")
oEntry.SetAttribute("name", "LschEintrag")
; der Text des Bausteins vorbelegen mit "leer"
oCData = goTextModuleFile.createCDATASection ("leer")
; und CData-Knoten zum Eintrag hinzufgen 
oEntry.AppendChild (oCData)
; Data-Knoten auswhlen 
oData = goTextModuleFile.getElementsByTagName("data").item(0)
; und als letzte Knoten den oben erstellten Eintrag hinzufgen 
oData.appendChild(oEntry)
; sowei Datei speichern 
goTextModuleFile.Save (gsFilename)
; und Meldung ausgeben 
SetTextModulNumber (cLast, MsgNew)
EndScript 

; -----------------------------------------------------------------------------------------------
; Eigene Schnelleinstellungen ffnen
; -----------------------------------------------------------------------------------------------

Script CobraStartSettings ()
If !gbTextModuleActive then
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgQuickSettingsError)
SendToBraille (MsgQuickSettingsErrorBraile)
Return
EndIf ; If !gbTextModuleActive then

PerformScript EndCobraTextModules ()

If !gbIsQuickSettingActive then
ScheduleFunction ("CloseQuickSettings", 5)
PerformScript QuickSettings ()
Pause ()
EndIf 

var
string sPath = GetJAWSDirectory (),
object oShell,
string sFile,
string sParam

sFile = GetJAWSDirectory () + "\\" + cQuickSettingsName
sParam = cQuickSettingsFile

oShell = CreateObject("Shell.Application")
oShell.ShellExecute(sFile, sParam, "", "open", 1)
oShell = Null()
EndScript 

; -----------------------------------------------------------------------------------------------
; Zustzliches Einfgen ber Dialog
; -----------------------------------------------------------------------------------------------

Script DlgTextModules ()
var
object oXML, 
object oEntries,
object oEntry,
string sEntry, 
string sTemp,
int iResult,
string sText

; Dateinamen fr XML-Datei zusammenstellen 
gsFilename = GetJAWSSettingsDirectory () + "\\" + cFilename
; MSXML-COM-Objekt erstellen 
goTextModuleFile = CreateObject("msxml2.DOMDocument.6.0")
; Einstellungen vornehmen 
goTextModuleFile.async = false;
goTextModuleFile.resolveExternals = false;
goTextModuleFile.setProperty("SelectionLanguage", "XPath")
; Falls die Textbausteindatei existiert 
If FileExists (gsFilename) then
; dies melden und Datei laden 
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgLoadXML)
SendToBraille (MsgLoadXML)
goTextModuleFile.Load (gsFilename)

; alle Eintrge laden 
oEntries = goTextModuleFile.getElementsByTagName("entry")

; Schleife ber alle gefundenen Eintrge
ForEach oEntry in oEntries 
; den Text des aktuellen Eintrags extrahieren 
sTemp = oEntry.FirstChild.Text
; Falls Zeilenumbrche vorkommen, dann nur die erste Zeile ermitteln
sTemp = StringSegment (sTemp, "#", 1)
; Wenn es mehr als 30 Zeichen sind 
If StringLength (sTemp) > 30 then
; den Rest abschneiden 
sTemp = StringLeft (sTemp, 30) + " (...)"
EndIf ; If StringLength (sTemp) > 30 then
; und der StringSegment-Liste hinzufgen 
sEntry = sEntry + sTemp + "|"
EndForEach
; gefundene Eintrge in Dialog anzeigen und Nummer des ausgewhlten Eintrags 
; in iResult speichern
iResult = DlgSelectItemInList (sEntry, cTitleDialog, True, 1)
; Wenn etwas gewhlt wurde 
If iResult then
; den Eintrag in sText speichern
sText = oEntries(iResult-1).FirstChild.Text
; # mit Zeilenumbrchen ersetzen 
sText = StringReplaceSubstrings (sText, "#", "\13\10")
; Text in die Zwischenablage 
CopyToClipboard (sText)
Pause ()
; und einfgen 
TypeKey ("Control+V")
SayFormattedMessage (OT_SCREEN_MESSAGE, MsgInsertTextModule)
SendToBraille (MsgInsertTextModule)
EndIf ; If iResult then
EndIf ; If FileExists (gsFilename) then
EndScript

